class test
{
private:
	int x;
public:
	test(){}
	char* fonc(int a);
	void fonc2(int* b);
	void fonc3(int& d);
};

char* test::fonc(int a) 
{
	x=a;  // 1
	a++;  // 2
	return "plouf";
}

void test::fonc2(int* b)
{
	*b = 5; // 3
	b++;    // 4
}

void test::fonc3(int& d)
{
	d=6;  // 5
}

int main()
{
	int table[3];
	int c = 5; 
	c=c+1;  // 6
	char* paf;
		
	table[0]=7;
	table[1]=13;
	table[2]=21;
	
	test t;
	paf=t.fonc(6);
	t.fonc2(&(table[0]));

	paf[0]='V';  // 7

	t.fonc3(c);

	return 0;
}



/*!F

  Ce tutorial - non fondamental - que je replacerai a la fin de la partie C++ - illustre les scurits sur const
  Ces scurits sont des protections en criture : le but est de se garantir qu'il n'y aura pas de modification spcifique
  dans une fonction, sans meme savoir ce qu'il y adedans.

  La scurit se fait juste au niveau de la compilation. Inutile de lancer le programme, essayez juste de le compiler.

  Par dfaut, a compile bien.

Maintenant, on va faire des modifications :

PROTECTION DES DONNEES MEMBRES :
******************************** 

  remplacez :

  char* fonc(int a);

  par

  char* fonc(int a) const

  (adaptez dans l'implmentation bien sur !!)

  Compilez : a geule au signet 1, alors que la mthode essaie de modifier la donnes membre x.
  En effet, mettre const a la sortie d'une mthode assure qu'elle ne modifiera pas les donnes membres.

  C'est une garantie pour celui qui appelle la mthode, il sait que son instance ne sera pas modifie.

PROTECTION DES PARAMETRES :
***************************

  Cette fois, adaptez fonc a la syntaxe suivante :

  char* test::fonc(const int a)

  Cette fois, a gueule sur le label 2, quand fonc essaie de modifier a.

  C'est une scurit pour celui qui implmente la mthode fonc
  mais galement une scurit si vous appelez a par rfrence :

  char* test::fonc(const int& a)

  dans ce cas c'est une scurit galement pour celui qui appelle la fonction, il est sur que sa variable passe
  par rfrence ne sera pas modifie.

PROTECTION DES CODES DE RETOUR :
********************************

  Adaptez fonc a la syntaxe suivante :

  const char* test::fonc(int a) 

  Adaptez galement la dfinition du main de la faon suivante :
  
  const char* paf;

  Cette fois, a gueule au label 7 : ce const certifie que la chaine passe en retour ne sera pas modifie.

PROTECTION DES POINTEURS :
**************************
2 cas :

cas criture sous pointeur :
----------------------------

  Remplacez fonc2 par :
  
  void fonc2(const int* b);

  void fonc2(int const * b);

  au choix : les 2 syntaxes sont acceptes.

  Cette fois, a gueule au label 3 :

  Cette syntaxe interdit simplement de modifier ce qu'il y a en dessous d'un pointeur.

cas dplacement de pointeur :
----------------------------

  Remplacez fonc2 par :

  void fonc2(int* const b);

  Cette fois, c'est au label 4 que a gueule. Vous ne pouvez pas dplacer le pointeur.

combin :
---------

  Remplacez fonc2 par :


  void fonc2(const int* const b);
  
  ou
	
  void fonc2(int const * const b);

  Cette fois, a gueule au 3 et au 4 : vous bloquez non seulement l'criture sous pointeur, mais le dplacement.


PROTECTION DES PARAMETRES ET CONSTANTES
***************************************

  Un peu comme vu plus haut, adaptez fonc 3 ainsi :
  
  void fonc3(const int& d);

  a gueule au label 5.

  Essayez maintenant, dans le main, de faire :

  t.fonc3(18);  // passer une constante pure.

  Avec la syntaxe :

  void fonc3(const int& d);

  a passe, car vous passez 18 en tant que constante, donc c'est bon

  Avec la syntaxe :

  void fonc3(int& d);

  a gueule, car vous passez 18 en tant que reference, sans protection en criture, donc il est susceptible d'etre modifi,
  ce qui est impensable pour ue constante balance comme dans le code en dur.


PROTECTION A L'INITIALISATION :
*******************************

  dans le main, dclarez la variable c ainsi.

  const int c = 5; 

  a marche un peu comme un #define c 5

  vous ne pourrez jamais modifier c : a gueule au label 6

  Evidemment, il faut assigner une valeur de dpart, si vous faites juste 

  const int c;  

  il vous dira que ce n'est pas bon, qu'il faut initialiser.




Voila les cas tordus de const, j'espere ne pas en avoir oubli :)

Note : mettre des const ou pas de const ne joue pas du tout sur l'xecution du programme :
tout se passe a la compilation. Dans le programme, une fois compil, il n'y a plus du tout de notion de const,
c'est juste pour protger le programmeur (ou pour l'emmerder, a dpend des points de vue)

!*/

/*!E
	No explanations yet.
!*/

/*
titre: Protection des classes et des donnes.
titreE: Protection of class and datas.
meta: C++
metaE: C++
desc : Protection des classes et des donnes  la compilation. 
descE : Protection of class and datas.
cle  : const
*/

